#!/bin/python3

import sys
import os
import progressbar

networks_url =    "https://zenodo.org/record/7230148/files/networks.zip"
default_url =     "https://zenodo.org/record/7230148/files/default.zip"
abc_url =         "https://zenodo.org/record/7230148/files/abc.zip"
pointclouds_url = "https://zenodo.org/record/7230148/files/point-clouds.zip"

bar = progressbar.ProgressBar(max_value=8, redirect_stdout=True)
bar_state = 0


def run(command, update=False):
    global bar, bar_state
    print(command)
    if os.system(command) != 0:
        print('Nonzero output after running "' + command + '", aborting')
        exit(1)
    if update:
        bar_state += 1
        bar.update(bar_state)


if __name__ == "__main__":
    full = len(sys.argv) > 1 and sys.argv[1] == '--full-abc'

    run('mkdir zips')
    run('wget ' + networks_url    + ' -P zips', True)
    run('wget ' + default_url     + ' -P zips', True)
    run('wget ' + abc_url         + ' -P zips', True)
    run('wget ' + pointclouds_url + ' -P zips', True)

    run('mkdir PLY')
    run('mkdir PLY/ABC')
    run('mkdir PLY/Other')
    run('mkdir Networks')
    run('unzip zips/networks.zip -d Networks', True)
    run('unzip zips/default.zip -d PLY/Other', True)
    run('unzip zips/point-clouds.zip -d PLY/Other', True)
    run('unzip zips/abc.zip -d PLY/ABC', True)

    run('./pced_replicability' + ('' if full else ' --small-abc'))
